using System;
using NUnit.Framework;

namespace Fines.Powershell.PowershellMSBuildTask.Tests
{
    [TestFixture]
    public class PowershellHostRawUITest
    {
        private PowershellHostRawUI rawUI;

        [SetUp]
        public void SetUp()
        {
            this.rawUI = new PowershellHostRawUI();
        }

        [TearDown]
        public void TearDown()
        {
        }

        [Test]
        public void BackgroundColor()
        {
            Assert.AreEqual( ConsoleColor.Black, this.rawUI.BackgroundColor );
        }

        [Test]
        public void ForegroundColor()
        {
            Assert.AreEqual( ConsoleColor.White, this.rawUI.ForegroundColor );
        }
    }
}
